{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#dedup.cwl/advanced_options"
                },
                {
                    "type": "string",
                    "default": "Dedup",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#dedup.cwl/algo"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--bam_compression",
                        "position": 110
                    },
                    "id": "#dedup.cwl/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "--dup_read_name"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#dedup.cwl/dup_read_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#dedup.cwl/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--interval",
                        "position": 10
                    },
                    "id": "#dedup.cwl/interval"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "--merge",
                        "position": 110
                    },
                    "id": "#dedup.cwl/merge"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--metrics",
                        "position": 110
                    },
                    "id": "#dedup.cwl/metrics"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--optical_dup_pix_dist",
                        "position": 110
                    },
                    "id": "#dedup.cwl/optical_dup_pix_dist"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "--output_dup_read_name",
                        "position": 110
                    },
                    "id": "#dedup.cwl/output_dup_read_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#dedup.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 180
                    },
                    "id": "#dedup.cwl/part_metrics"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#dedup.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "--rmdup",
                        "position": 110
                    },
                    "id": "#dedup.cwl/rmdup"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "--score_info"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#dedup.cwl/score_info"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#dedup.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#dedup.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--traverse_param",
                        "position": 10
                    },
                    "id": "#dedup.cwl/traverse_param"
                }
            ],
            "stderr": "dedup.log",
            "id": "#dedup.cwl",
            "outputs": [
                {
                    "type": "File",
                    "id": "#dedup.cwl/log",
                    "outputBinding": {
                        "glob": "dedup.log"
                    }
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.metrics)"
                    },
                    "id": "#dedup.cwl/metrics_output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": ".bai",
                    "id": "#dedup.cwl/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sentieon",
                "driver"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 110
                    },
                    "id": "#dedup_pre.cwl/advanced_options"
                },
                {
                    "type": "string",
                    "default": "LocusCollector",
                    "inputBinding": {
                        "position": 100,
                        "prefix": "--algo"
                    },
                    "id": "#dedup_pre.cwl/algo"
                },
                {
                    "type": "string",
                    "default": "score_info",
                    "inputBinding": {
                        "prefix": "--fun",
                        "position": 110
                    },
                    "id": "#dedup_pre.cwl/fun"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ],
                            "inputBinding": {
                                "prefix": "-i"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 10
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#dedup_pre.cwl/input_bam"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 150
                    },
                    "id": "#dedup_pre.cwl/output_file"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-r"
                    },
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#dedup_pre.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--shard",
                        "position": 10
                    },
                    "id": "#dedup_pre.cwl/shard"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 10
                    },
                    "id": "#dedup_pre.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--traverse_param",
                        "position": 10
                    },
                    "id": "#dedup_pre.cwl/traverse_param"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#dedup_pre.cwl/log",
                    "outputBinding": {
                        "glob": "dedup_pre.log"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "secondaryFiles": ".tbi",
                    "id": "#dedup_pre.cwl/output"
                }
            ],
            "stderr": "dedup_pre.log",
            "id": "#dedup_pre.cwl"
        },
        {
            "class": "Workflow",
            "doc": "run 3-pass dedup: algo LocusCollector + algo Dedup output_dup_read_name + algo Dedup dedup_by_read_name sequentially",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#main/advanced_options/dedup_pre",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                },
                                {
                                    "name": "#main/advanced_options/dedup",
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    "id": "#main/advanced_options"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/bam_compression"
                },
                {
                    "type": [
                        {
                            "type": "array",
                            "items": [
                                "string",
                                "File"
                            ]
                        }
                    ],
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#main/input_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "id": "#main/interval"
                },
                {
                    "type": "string",
                    "id": "#main/metrics_output_file"
                },
                {
                    "type": "string",
                    "id": "#main/output_file"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/traverse_param"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/dup_read_name/metrics_output",
                    "id": "#main/metrics_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/dedup_by_read_name/output",
                    "id": "#main/output"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/advanced_options",
                            "valueFrom": "${ return self ? self.dedup : []; }\n",
                            "id": "#main/dedup_by_read_name/advanced_options"
                        },
                        {
                            "source": "#main/bam_compression",
                            "id": "#main/dedup_by_read_name/bam_compression"
                        },
                        {
                            "source": "#main/dup_read_name/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/dedup_by_read_name/dup_read_name"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/dedup_by_read_name/input_bam"
                        },
                        {
                            "source": "#main/interval",
                            "id": "#main/dedup_by_read_name/interval"
                        },
                        {
                            "source": "#main/output_file",
                            "id": "#main/dedup_by_read_name/output_file"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/dedup_by_read_name/reference"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/dedup_by_read_name/threads"
                        },
                        {
                            "source": "#main/traverse_param",
                            "id": "#main/dedup_by_read_name/traverse_param"
                        }
                    ],
                    "out": [
                        "#main/dedup_by_read_name/output"
                    ],
                    "run": "#dedup.cwl",
                    "id": "#main/dedup_by_read_name"
                },
                {
                    "in": [
                        {
                            "source": "#main/advanced_options",
                            "valueFrom": "${ return self ? self.dedup_pre : []; }\n",
                            "id": "#main/dedup_pre/advanced_options"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/dedup_pre/input_bam"
                        },
                        {
                            "source": "#main/output_file",
                            "valueFrom": "$(self).score.gz",
                            "id": "#main/dedup_pre/output_file"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/dedup_pre/reference"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/dedup_pre/threads"
                        },
                        {
                            "source": "#main/traverse_param",
                            "id": "#main/dedup_pre/traverse_param"
                        }
                    ],
                    "out": [
                        "#main/dedup_pre/output"
                    ],
                    "run": "#dedup_pre.cwl",
                    "id": "#main/dedup_pre"
                },
                {
                    "in": [
                        {
                            "source": "#main/advanced_options",
                            "valueFrom": "${ return self ? self.dedup : []; }\n",
                            "id": "#main/dup_read_name/advanced_options"
                        },
                        {
                            "source": "#main/bam_compression",
                            "id": "#main/dup_read_name/bam_compression"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/dup_read_name/input_bam"
                        },
                        {
                            "source": "#main/interval",
                            "id": "#main/dup_read_name/interval"
                        },
                        {
                            "source": "#main/metrics_output_file",
                            "id": "#main/dup_read_name/metrics"
                        },
                        {
                            "valueFrom": "${ return true; }",
                            "id": "#main/dup_read_name/output_dup_read_name"
                        },
                        {
                            "source": "#main/output_file",
                            "valueFrom": "$(self).dup_read_name.gz",
                            "id": "#main/dup_read_name/output_file"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/dup_read_name/reference"
                        },
                        {
                            "source": "#main/dedup_pre/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/dup_read_name/score_info"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/dup_read_name/threads"
                        },
                        {
                            "source": "#main/traverse_param",
                            "id": "#main/dup_read_name/traverse_param"
                        }
                    ],
                    "out": [
                        "#main/dup_read_name/output",
                        "#main/dup_read_name/metrics_output"
                    ],
                    "run": "#dedup.cwl",
                    "id": "#main/dup_read_name"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
